package com.wartbar.history

import org.gradle.api.DefaultTask
import org.gradle.api.file.FileCollection
import org.gradle.api.tasks.TaskAction
import com.wartbar.util.HtmlToolbox

class HistoryGeneratorBuildTask extends DefaultTask {

  FileCollection sourceFiles

  File outputFile = new File("historyCompiled.md")

  private void build() {
    sourceFiles.each { File f ->

      def lines = f.readLines()

      lines.each {

        String itemText = it.replace("#","").trim()
        String item = itemText.subSequence(9,itemText.size()).replaceAll(" ","-").toLowerCase()

        outputFile << "[" + itemText + "](" + f.name.replace("history.md",".html") + "#" + item + ")<br>\n"
      }
    }
  }

  private void init() {
    outputFile.delete()
    outputFile << HtmlToolbox.standardHeader("History, The Index Of This Blog")
    outputFile << '<section id="section">\n'

  }

  private void footer() {
    outputFile << '[20160216 Me](me.html)<br>\n'
    outputFile << '20160216 Start Of This Blog<br>\n'
    outputFile << '</section>\n'
    outputFile << '</html>\n'
  }

  @TaskAction
  public void generate() {
    init()
    build()
    footer()
  }
}
