package com.wartbar.history

import org.gradle.api.DefaultTask
import org.gradle.api.tasks.TaskAction
import org.gradle.api.tasks.InputFile
import org.gradle.api.tasks.OutputFile

class HistoryGeneratorTask extends DefaultTask {

    @InputFile
    File sourceFile

    @OutputFile
    File destinationFile

    def posts = []

    private void collectPosts() {

        def lines = sourceFile.readLines()

        for (line in lines) {
            if (line.startsWith("### 20")) {
                posts.add(line)
            }
        }
    }

    private void generateOutput() {
        posts.each {
            destinationFile << it << "\n"
        }
    }

    private void init() {
      destinationFile.delete()
      destinationFile.getParentFile().mkdirs()
    }

    @TaskAction
    public void generate() {
        init()
        collectPosts()
        generateOutput()
    }
}
