package com.wartbar.topic

import org.gradle.api.DefaultTask
import org.gradle.api.file.FileTree
import org.gradle.api.tasks.TaskAction
import org.gradle.api.tasks.InputFile
import org.gradle.api.tasks.OutputFile

import com.wartbar.util.HtmlToolbox

class TagCompilerTask extends DefaultTask {

  String getTopic(String line) {
      return line.replaceAll("\\[", "").replaceAll("\\]","")
  }

  String getTitle(String line) {
    return line.replaceAll("<", "").replaceAll(">","").replaceAll("-","")
  }

  @TaskAction
  public void compile() {


    FileTree treeDeleter = project.fileTree(dir: '.', include: '**/*Compiled.md', exclude: 'excluded/')
    treeDeleter.each { File file ->
      file.delete()
    }

    FileTree tree = project.fileTree(dir: '.', include: '**/*.md', exclude: 'excluded/')
    tree.each {File file ->

      File destinationFile = new File(file.getName().replaceAll(".md","")+"Compiled.md")
      destinationFile.delete()

      def lines = file.readLines()

      lines.each {
        if (it.startsWith("[[")) {
          String topic = getTopic(it)
          destinationFile << '[['
          destinationFile << topic
          destinationFile << ']]('
          destinationFile << 'topic_' + topic.replace(" ", "_")
          destinationFile << '.html)\n'
          return
        }

        if (it.startsWith("<<")) {
          destinationFile << HtmlToolbox.standardHeader(getTitle(it))
          return
        }

        if (it.startsWith("--")) {
          destinationFile << HtmlToolbox.simpleHeader(getTitle(it))
          return
        }

        destinationFile << it << '\n'
      }
    }

    }
}
