package com.wartbar.topic

import com.wartbar.util.HtmlToolbox

class TopicFileGenerator {

    public TopicFileGenerator() {}

    String getID(String post) {
        return post.toLowerCase().replaceAll(" ", "-")
    }

    void writePost(File f, String post) {
        f << '<div>['
        f << post
        f << '](index.html#'
        f << getID(post)
        f << ')</div><br>\n'
    }

    void create(def map) {
        map.each {
            String filename = "topic_" + it.key.replace(" ","_") + "Compiled"
            File f = new File("topics/${filename}.md")
            f.delete()

            f << HtmlToolbox.standardHeader("Andre's Blog Posts About ${it.key}")

            def posts = map[(it.key)]
            posts[posts.size()-1..0].each {
                writePost(f,it)
            }
        }
    }
}