package com.wartbar.topic

class TopicMap {

    def map = [:]

    def accessMap() {
        return map
    }

    String getTopic(String line) {
        return line.replaceAll("\\[", "").replaceAll("\\]","")
    }

    String getPost(String line) {
        String[] parts = line.split(" ")
        String post = ""

        parts[2..parts.length-1].each {
            post += "${it} "
        }

        post = post[0..post.size()-2]

        return post
    }

    void add(String line, String lastPost) {
        String topic = getTopic(line)
        if (map[(topic)] == null) {
            def posts = []
            posts.add(lastPost)
            map.put((topic), posts)
        } else {
            def posts = map[(topic)]
            posts << lastPost
        }
    }

    public TopicMap(File inputFile) {
        def lines = inputFile.readLines()
        String lastPost

        for (line in lines) {
            if (line.startsWith("### 20")) {
                lastPost = getPost(line)
            }

            if (line.startsWith("[[")) {
                add(line,lastPost)
            }
        }
    }
}

