package com.wartbar.topic

import com.wartbar.util.HtmlToolbox

class TopicMenuGenerator {

    public TopicMenuGenerator() {}

    void writeTopicListFooter(File f) {
        f << '</html>\n'
    }

    void writeData(File f, String x) {
        f << '<td>'

        if (!x.isEmpty()) {
            f << '<a class="paddedTable" href="topic_'
            f << x.replace(" ","_")
            f << '.html">'
            f << x
            f << '</a>'
        }

        f << '</td>\n'
    }

    void writeTopicRow(File f, String a, String b, String c, String d) {
        f << '<tr>\n'

        writeData(f,a)
        writeData(f,b)
        writeData(f,c)
        writeData(f,d)

        f << '</tr>\n'
    }

    String element(ArrayList<String> list, int index) {
        if (index < list.size()) {
            return list.get(index)
        } else {
            return ""
        }
    }
/*
    void writeTopicListHeader(File f, String topic) {

        f << '''<!DOCTYPE html>
<html style="background-color:black;text-align:center;">
<head>
<link rel="stylesheet" type="text/css" href="format.css">
<link rel="alternate" type="application/rss+xml" title="RSS" href="http://www.wartbar.de/rss.xml">
</head>
<br>
<h1>'''

        f << topic

        f << '''</h1>
<br>
<a href="menu.html"><img src="pic/menu.jpg" width="50" ></a>
<br>
<br>
<section id="section">'''
    }
*/

    void create(def map) {
        File f = new File("topics.md")
        f.delete()

        f << HtmlToolbox.standardHeader("Andre's Blog Post Topics")
        //writeTopicListHeader(f,"Andre's Blog Post Topics")

        ArrayList<String> orderedList = new ArrayList<>()
        orderedList.addAll(map.keySet())
        Collections.sort(orderedList)

        println "Topic Count : " + orderedList.size()

        f << '<table class="paddedTable" align="center">\n'


        int divider = (orderedList.size() / 4) + 1

        for (int i=0; i<divider; i++) {
            String a = element(orderedList, i)
            String b = element(orderedList, i + divider)
            String c = element(orderedList, i + (2*divider))
            String d = element(orderedList, i + (3*divider))

            writeTopicRow(f, a, b, c, d )
        }

        f << "</table>\n"

        writeTopicListFooter(f)
    }
}